module i2c_master_config(
							clk_12m,
							rst_n,
							scl,
							sda,
							i2c_clk,
							i2c_dev_addr,
							i2c_reg_addr,
							i2c_reg_data,
							i2c_read_data,
							i2c_config,
							i2c_ack,
							state_debug,
							at24c02_00_data
							);
	
	input			clk_12m;			//ϵͳʱ = 12M
	input			rst_n;				//λźţ͵ƽЧ
	output			scl;				//I2Cʱź
	inout			sda;				//I2Cź
	input			i2c_clk;			//ʱܽţ100K or 400K;	
	output	[7:0]	i2c_read_data;		//I2C
	output	[7:0]	i2c_config;			//I2Cܽ
	output	[6:0]	i2c_dev_addr;		//I2Cӻ豸ַ	
	output	[7:0]	i2c_reg_addr;		//I2CдĿĴַ
	output	[7:0]	i2c_reg_data;		//I2CдĿĴ
	output	[7:0]	state_debug;		//I2C״ָ̬ʾ
	output	[7:0]	i2c_ack;			//I2CӦλ
	output	[7:0]	at24c02_00_data;

	i2c_master_logic i2c_master_logic_inst(
		.clk_in(i2c_clk),
		.rst_n(rst_n),
		.scl(scl),
		.sda(sda),
		.i2c_read_data(i2c_read_data),
		.i2c_device_address(i2c_dev_addr),
		.i2c_reg_address(i2c_reg_addr),
		.i2c_write_reg_data(i2c_reg_data),
		.state_debug(state_debug),
		.i2c_config(i2c_config),
		.i2c_ack(i2c_ack)
		);
	
	
	parameter		I2C_Wait					=	8'h00;	//I2CSCL = 1SDA = z;
	parameter		I2C_Single_Write_Byte		= 	8'h01;	//I2Cдģʽʼ--豸ַд-ACK-Ĵַ-ACK-Ĵ-ACK-ֹͣ
	parameter		I2C_Continuous_Write_Byte	=	8'h02; 	//I2Cдģʽʼ--豸ַд-ACK-Ĵַ-ACK-Ĵ-ACK-Ĵ-ACK-Ĵ-ACK
	parameter		I2C_Write_Directly			=	8'h03; 	//I2Cֱдģʽʼ--豸ַд-ACK-Ĵ-ACK-ֹͣ
	parameter		I2C_Single_Read_Byte		=	8'h04; 	//I2Cζģʽʼ--豸ַд-ACK-Ĵַ-ACK-ʼ2-豸ַ-ACK-ȡ-NACK-ֹͣ
	parameter		I2C_Continuous_Read_Byte	=	8'h05; 	//I2Cģʽʼ--豸ַд-ACK-Ĵַ-ACK-ʼ2-豸ַ-ACK-ȡ-ACK-ȡ-ACK-ȡݡ
	parameter		I2C_Read_Directly			=	8'h06; 	//I2CֱӶȡģʽʼ--豸ַд-ACK-ʼ2-豸ַ-ACK-ȡ-NACK-ֹͣ
	
	
	//ʽ״̬I2CͨѶģʽá
	
	
	reg	[1:0]	i2c_state;		//I2C״̬
	
	wire	i2c_flag;
	assign	i2c_flag = i2c_ack[2] | i2c_ack[5];
	
	//һ״̬
	always@(posedge i2c_flag or negedge rst_n) begin 
		if(!rst_n) 
			i2c_state <= 8'h00;
		else if(i2c_state == 8'h02)
			i2c_state <= 8'h02;
		else 
			i2c_state <= i2c_state+ 1'b1;	
	end
	
	//ڶڶӦ״̬УI2Cģʽزѡ
	
	reg		[7:0]	at24c02_00_data;
	
	reg		[6:0]	i2c_dev_addr;	//豸ַ
	reg		[7:0]	i2c_reg_addr;	//Ĵַ
	reg		[7:0]	i2c_reg_data;	//Ĵ(дЧ)
	reg		[7:0]	i2c_config;		//I2CģʽüĴ
	always@(posedge clk_12m or negedge rst_n) begin 
		if(!rst_n) begin 
			i2c_config	<=	8'd0;
			i2c_dev_addr<=	7'd0;
			i2c_reg_addr<=	8'd0;
			i2c_reg_data<=	8'd0; end
		else begin 
			case(i2c_state)
				//״̬0дģʽAT24C02е00ַдBB
				0	:	begin	i2c_config		<= I2C_Single_Write_Byte;	
								i2c_dev_addr	<= 8'h50;
								i2c_reg_addr	<= 8'h00;		
								i2c_reg_data	<= 8'hBB;	end	
				//״̬1ζȡģʽȡAT24C02е00ַݲݴ洢ڼĴ
				1	:	begin	i2c_config		<= I2C_Single_Read_Byte;	
								i2c_dev_addr	<= 8'h50;
								i2c_reg_addr	<= 8'h00;		
								at24c02_00_data	<= i2c_read_data;	end	
				//״̬2ͨѶɣ߹
				2	:	begin	i2c_config		<= I2C_Wait;	end											
			default	:	begin 	i2c_config		<= 8'd0;	end				
			endcase
		end
	end
	
	
			    
endmodule
